// sound_volume.cpp : Defines the entry point for the DLL application.
//

#include <windows.h>
#include "master_volume.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

void debug_msg(LPCSTR e)
{
  OutputDebugStringA(e);
}

void WINAPI mayumaster(LPCSTR lpParam)
{
  try
  {
    int dwVolume;
    const  MAX_VOL = 0xFFFF;

    switch(lpParam[0])
    {
    case '+': case '-':
      dwVolume = (int)(master_volume_get() + atof(lpParam) * MAX_VOL / 100);
      break;
    case '*':
      dwVolume = (int)(master_volume_get() * atof(lpParam + 1));
      break;
    case '/':
      dwVolume = (int)(master_volume_get() / atof(lpParam + 1));
      break;
    default:
      dwVolume = (int)(atof(lpParam) * MAX_VOL / 100);
      break;
    }

    master_volume_set(dwVolume < 0 ? 0 : dwVolume);
  }
  catch(LPCSTR e)
  {
    debug_msg(e);
  }
}

void WINAPI mayumaster_mute(LPCSTR lpParam)
{
  try
  {
    BOOL bMute;

    switch(lpParam[0])
    {
    case '0':
      bMute = 0;
      break;
    case '1':
      bMute = 1;
      break;
    default:
      bMute = !master_volume_get_mute();
      break;
    }

    master_volume_set_mute(bMute);
  }
  catch(LPCSTR e)
  {
    debug_msg(e);
  }
}
